;============================================================
;Clock v1.50 by Arie Benichou.
;<ArteFact@Hotmail.com>
;1999.11.10

;This program has been tested on a TI-89 with rom 1.00.
;You should use Word to look at the source correctly.
;============================================================
			include		tios.h
;============================================================
			xdef    		_main
			xdef			_comment
			xdef			_ti89
;============================================================
x			equ			120
y			equ			95
mask0 		equ 			%11111110
mask1 		equ 			%11111101
mask2 		equ 			%11111011
mask3 		equ 			%11110111
mask4 		equ 			%11101111
mask5 		equ 			%11011111
mask6 		equ 			%10111111
laps1			equ			1092
laps2			equ			20
;============================================================
SetFont:		MACRO						
			movem.l		d0-d7/a0-a6,-(a7)
			move.w		\1,-(a7)			
			jsr			tios::FontSetSys	
			add.l			#2,a7				
			movem.l		(a7)+,d0-d7/a0-a6
			ENDM
;------------------------------------------------------------
Disp: 		MACRO
			movem.l		d0-d7/a0-a6,-(a7)
			clr.l  		d1
 			move.w 		\1,d1
 			bsr    		String
			move.w 		\4,-(a7)
 			move.l 		a0,-(a7)
 			move.w 		\2,-(a7)
 			move.w 		\3,-(a7)
 			jsr			tios::DrawStrXY
 			lea     		10(a7),a7
			movem.l		(a7)+,d0-d7/a0-a6
			ENDM
;------------------------------------------------------------
PxlText:		MACRO
			movem.l		d0-d7/a0-a6,-(a7)
			move.w 		\4,-(a7)
 			move.l 		\1,-(a7)
 			move.w 		\2,-(a7)
 			move.w 		\3,-(a7)
 			jsr			tios::DrawStrXY
 			lea     		10(a7),a7
			movem.l		(a7)+,d0-d7/a0-a6
			Endm
;============================================================
_main: 		cmp.l			#$120,$90
			beq			Uninstall 
;------------------------------------------------------------			
Install:		move.l 		($74),old_int5
			move.l 		($90),old_trap4
			SetFont		#0
			PxlText		#help,#95,#0,#4
			PxlText		#dots,#y,#x+8,#4
			bsr 			NewInts
Change:		bra			DispChange
;============================================================
SetClock: 		move.w   		#mask0,d0
			bsr			GetKey
			btst     		#3,d0
			beq			AddMinute
  			btst     		#1,d0
			beq			SubMinute
			btst     		#0,d0
			beq			AddHour
  			btst     		#2,d0              
			beq			SubHour
			move.w   		#mask1,d0
			bsr			GetKey
			btst     		#0,d0
			bne			SetClock
			bsr			OldInts
;============================================================
InstallTrap4:  	move.l		#EndTrap4-Trap4-1,d0

			lea			Trap4(PC),a0
			move.l		#$120,a1

\WriteTrap4:	move.b		(a0)+,(a1)+
			dbra			d0,\WriteTrap4
			bclr			#2,$600001
			move.l		#$120,$90
			bset			#2,$600001
;============================================================
InstallInt5:	move.l		#EndInt5-Int5-1,d0

			lea			Int5(PC),a0
			move.l		#$180,a1
\WriteInt5:		move.b		(a0)+,(a1)+
			dbra			d0,\WriteInt5
			bclr			#2,$600001
			move.l		#$180,$74
			bset			#2,$600001
;============================================================
			move.l		#laps1-1,timer1
			sub.w			#1,minutes
			move.w		#laps2-1,timer2
			rts
;============================================================
NewInts:		move.l 		($64),int_1
			move.l 		($74),int_5
        		bclr.b 		#2,($600001)
        		move.l 		#NewInt1,($64) 
			move.l 		#NewInt5,($74) 
        		bset.b 		#2,($600001)
			rts
;------------------------------------------------------------
NewInt1:		rte
;------------------------------------------------------------
NewInt5:		rte
;------------------------------------------------------------
OldInts:		bclr.b 		#2,($600001)
			move.l 		int_1,($64) 
			move.l 		int_5,($74) 
        		bset.b 		#2,($600001)
			rts
;------------------------------------------------------------
 Uninstall:		bclr			#2,$600001
			move.l 		old_trap4,($90)
			move.l 		old_int5,($74)
			bset			#2,$600001
			rts
;------------------------------------------------------------
GetKey:		move.w		d0,$600018 
			bsr			Wait
			move.b		$60001b,d0
			rts		
;------------------------------------------------------------
Wait:			move.w		#500,d1
\loop1:		move.w		#150,d2
\loop2:		dbra			d2,\loop2
			dbra			d1,\loop1
			rts		
;------------------------------------------------------------
AddMinute:		add.w    		#1,minutes
	 		cmp.w    		#60,minutes
			bne			DispChange
			move.w    		#0,minutes
			bra			DispChange 
;------------------------------------------------------------
SubMinute:		add.w    		#-1,minutes
	 		cmp.w    		#-1,minutes
			bne			DispChange
			move.w    		#59,minutes
			bra			DispChange 
;------------------------------------------------------------
AddHour:		add.w    		#1,hours
	 		cmp.w    		#24,hours
			bne			DispChange
			move.w    		#0,hours
			bra			DispChange 
;------------------------------------------------------------
SubHour:		add.w    		#-1,hours
	 		cmp.w    		#-1,hours
			bne			DispChange
			move.w    		#23,hours
			bra			DispChange 
;------------------------------------------------------------
DispChange:		Disp	 		minutes,#y,#x+10,#4
			Disp	 		hours,#y,#x,#4
			bra			SetClock
;------------------------------------------------------------
help:			dc.b			"USE ",21,22,23,24," + [ENTER]                             r",0
int_1:		ds.l 			1
int_5:		ds.l 			1
old_trap4:		ds.l			1
old_int5:		ds.l			1
;============================================================




;============================================================
Trap4:		movem.l		d0-d7/a0-a6,-(a7)
	 		move.l		#1000,d3
\loop3:		move.w		#200,d4
\loop4:		dbra			d4,\loop4
			dbra			d3,\loop3
			move.w		#$FF,$60001C
			movem.l		(a7)+,d0-d7/a0-a6
			rte
EndTrap4
;============================================================




;============================================================
Int5:			movem.l		d0-d7/a0-a6,-(a7)
			add.l			#1,timer1
			bra			DispTime
;------------------------------------------------------------
CheckTime:		clr.l    		timer1
;------------------------------------------------------------
\CheckMinutes:	add.w    		#1,minutes
			cmp.w    		#60,minutes
			beq			\CheckHours
			bra			DispTime
;------------------------------------------------------------
\CheckHours:	clr.w    		minutes
			add.w    		#1,hours
 			cmp.w    		#24,hours
			bne			DispTime
			clr.w    		hours
;------------------------------------------------------------
DispTime: 		cmp.l			#laps1,timer1
			beq			CheckTime
			add.w			#1,timer2
			cmp.w			#laps2,timer2
			bne			ExitInt5
			clr.w			timer2
			jsr			tios::FontGetSys
			SetFont		#0
			Disp	 		minutes,#y,#x+10,#4
			PxlText		#dots,#y,#x+8,#4
			Disp	 		hours,#y,#x,#4
			SetFont		d0
ExitInt5:		movem.l		(a7)+,d0-d7/a0-a6
			rte
;------------------------------------------------------------
String: 		move.w 		#str+2,a0
 			clr.b	 		(a0)
 			clr.l	  		d2
\StringLoop: 	add.b 	 	#1,d2
 			divu	   		#10,d1
 			swap	   		d1
 			add.b	  		#48,d1
 			move.b	 	d1,-(a0)
 			clr.w	  		d1
 			swap	   		d1
 			tst.w	  		d1
 			bne	    		\StringLoop
 			cmp.b	  		#2,d2
 			beq  	  		EndString
 			clr.l  		d1
 			add.b  		#48,d1
 			move.b 		d1,-(a0)
EndString:		rts
;------------------------------------------------------------
dots:			dc.b			":",0
str:			ds.b  		2
minutes: 		ds.w	  		1
hours:   		ds.w	  		1
timer1:  		ds.l  		1
timer2:		ds.w			1
EndInt5
;============================================================




;============================================================
_comment:		dc.b			"Clock by ArteFact",0
;============================================================
			end

